#include "eigen.h"
#include "math.h"

void eigen(int n, const float * a, float * x, float * y)
{
    //  y = Ax
    for (int i = 0; i < n; ++i)
    {
        float sum = 0.0f;
        for (int j = 0; j < n; ++j)
            sum += a[i * n + j] * x[j];
        y[i] = sum;
    }

    //       y
    float yMax = fabs(y[0]);
    for (int i = 0; i < n; ++i)
        if (fabs(y[i]) > yMax)
            yMax = fabs(y[i]);

    // x = y / yMax
    for (int i = 0; i < n; ++i)
        x[i] = y[i] / yMax;
}
